;*********************** FLT cracktro by YRAGAEL ********************
;*********************** 28 Decembre 1993 ***************************
	opt	c-

	section data,code_c

;*************** PARAMETRES DE L'ECRAN ***************

nbplane=5
sizex=320
sizey=206

startx=129				;depart horizontal du trac
starty=45				;depart vertical du trac

tracex=320				;largeur de l'image a tracer  ...
					;... partir de startx

displayx=320				;largeur de l'image a visualiser  ...
					;... partir de startdisplayx
displayy=sizey				;hauteur de l'image a visualiser  ...
					;... partir de starty

startdisplayx=129			;debut horizontal visible de l'image

stopx=displayx+startdisplayx-256	;fin horizontale visible de l'image 
stopy=displayy+starty-256		;fin verticale visible de l'image

ddf_strt=(startx-17)/2 
ddf_stop=ddf_strt+(tracex/2-8)

modulo_pair=(sizex-tracex)/8
modulo_impair=(sizex-tracex)/8

planesize=sizey*sizex/8

;*************** CONSTANTES ***************

;----- Pages de texte -----

Page_Timer=300
Page_speed=2

;----- amplitude de variation des angles -----

Delta_X=2
Delta_Y=3

;----- divers -----

memory=2+$10000
copsize=32*4+9*4+2*4+8*nbplane+(sizey+3)*12+4

;32*4 (couleurs)
;9*4 (donnees screen)
;8*nbplane (adresses bitplanes)
;(sizey+3)*8 (sizey+2 coppelines + noir)
;+4 $FFFF FFFE (fin de copperlist)

;*************** MACROS ***************

;----- attente blitter -----

WaitBlit:	macro
Wait_Blit\@
		btst #14,dmaconr(a5)
		bne Wait_Blit\@
		endm

;----- attente VBL -----

WaitVBL:	macro
Wait_VBL\@
		cmp.b #$FF,vhposr(a5)
		bne Wait_VBL\@
		endm

;----- attente reelle VBL -----

WaitRealVBL:	macro
Wait_1stVBL\@
		cmp.b #$FF,vhposr(a5)
		bne Wait_1stVBL\@
Wait_2ndVBL\@
		cmp.b #$FE,vhposr(a5)
		bne Wait_2ndVBL\@
		endm

;*************** PROGRAMME PRINCIPAL ***************

;on travaille dans une scene 3d des lignes 10 a 210 (inclues)
;les constantes qui determinent la scene sont en fin de programme !

;----- sauvegarde des registres -----

	movem.l d0-d7/a0-a6,-(sp)

;----- initialisation -----

	bsr Init

;----- initialisations music -----

	bsr module_adr
	bsr module_adr+4
	moveq #0,d0
	bsr module_adr+12

;----- texte -----

	movea.l screen_adr(pc),a0
	add.l #(nbplane-2)*planesize,a0
	lea text_adr(pc),a1
	lea font8_adr(pc),a2
	bsr Printer
	movea.l screen_adr(pc),a0
	add.l #(nbplane-1)*planesize,a0
	bsr Printer
	movea.l screen_adr(pc),a0
	add.l #nbplane*planesize,a0
	bsr Printer
	lea $DFF000,a5

;----- apparition ------

	movea.l cop_adr(pc),a0
	lea 32*4+9*4+2*4+8*nbplane+12*((sizey+2)/2-1)+6(a0),a0
	lea 12(a0),a1
	rept (sizey+2)/2-1
	WaitVBL
	bsr module_adr+24
	move.w #$0003,(a0)
	move.w #$8100,4(a0)
	move.w #$0003,(a1)
	move.w #$8100,4(a1)
	lea -12(a0),a0
	lea 12(a1),a1
	move.w #$0FFF,(a0)
	move.w #$0FFF,(a1)
	endr

;------ initialisation de parametres ------

Main:
	move.l #$0000FFFF,d7	;d7=offset copperlist : flag de fin
	lea Main(pc),a6
	movea.l buffer_adr(pc),a0
	move.w #2*(360-Delta_X),angle_X-Main(a6)
	move.w #2*(360-Delta_Y),angle_Y-Main(a6)

	moveq #0,d1
	moveq #0,d2
	move.w #Page_Timer-1,d3
	movem.l d1-d3,-(sp)

;----- programme principal -----

Main_Loop:

;----- attente VBL -----

	WaitVBL

;----- music -----

	bsr module_adr+24

;----- disparition ------

	tst.w d7
	blt Main_NoEnd
	dbf d7,Main_Disparition
	bra Main_End
Main_Disparition:
	movea.l cop_adr(pc),a2
	lea 32*4+9*4+2*4+8*nbplane+6(a2),a2
	lea 12*(sizey+2)(a2),a1
	swap d7
	add.w d7,a2
	sub.w d7,a1
	move.w #$0000,(a2)
	move.w #$0000,(a1)
	lea 12(a2),a2
	lea -12(a1),a1
	move.w #$0FFF,(a2)
	move.w #$0100,4(a2)
	move.w #$0FFF,(a1)
	move.w #$0100,4(a1)
	add.w #12,d7
	swap d7
Main_NoEnd:

;------ swappe les bitplanes ------	

	movea.l cop_adr(pc),a2
	move.w 43*4+18(a2),d1		;bpl2pth
	swap d1
	move.w 43*4+22(a2),d1		;bpl2ptl
	move.w 43*4+14(a2),43*4+22(a2)	;bpl2ptl<-bpl1ptl
	move.w 43*4+10(a2),43*4+18(a2)	;bpl2pth<-bpl1pth
	move.w 43*4+2(a2),43*4+10(a2)	;bpl1pth<-bpl0pth
	move.w 43*4+6(a2),43*4+14(a2)	;bpl1ptl<-bpl0ptl
	move.l a0,d2
	move.w d2,43*4+6(a2)
	swap d2
	move.w d2,43*4+2(a2)
	move.l d1,a0

;----- hardscroll du texte -----

	movem.l (sp)+,d1-d3

	or.w d1,d1
	beq Main_NoHardUP
	movea.l cop_adr(pc),a1
	move.w 43*4+34(a1),d0
	swap d0
	move.w 43*4+38(a1),d0
	addi.l #Page_speed*sizeX/8,d0
	move.w d0,43*4+38(a1)
	swap d0
	move.w d0,43*4+34(a1)
	subq.w #1,d1
Main_NoHardUP:

	or.w d2,d2
	beq Main_NoHardDOWN
	movea.l cop_adr(pc),a1
	move.w 43*4+34(a1),d0
	swap d0
	move.w 43*4+38(a1),d0
	subi.l #Page_speed*sizeX/8,d0
	move.w d0,43*4+38(a1)
	swap d0
	move.w d0,43*4+34(a1)
	subq.w #1,d2
Main_NoHardDOWN:

	or.w d2,d2
	bne Main_PageTimerOK
	or.w d1,d1
	bne Main_PageTimerOK
	dbf d3,Main_PageTimerOK
	move.w #Page_Timer-1,d3
	lea page_script(pc),a1
	move.w (a1),d2
	move.w 2(a1),d1
	move.l (a1),d0
	rept 3
	move.l 4(a1),(a1)+
	endr
	move.l d0,(a1)
Main_PageTimerOK:

	movem.l d1-d3,-(sp)

;------ efface le buffer de travail ------

	WaitBlit
	move.w #0,bltdmod(a5)
	move.w #0,bltcon1(a5)
	move.w #%0000000111001100,bltcon0(a5)
	move.w #$0000,bltbdat(a5)
	move.l a0,bltdpth(a5)
	move.w #sizex/16+sizey*64,bltsize(a5)

;------ effectue la rotation X ------

	move.w angle_X(pc),d1
	subq.w #2*Delta_X,d1
	bge RotationX
	move.w #2*(360-Delta_Y),d1
RotationX:
	move.w d1,angle_X-Main(a6)

;------ effectue la rotation Y ------

	move.w angle_Y(pc),d1
	subq.w #2*Delta_Y,d1
	bge RotationY
	move.w #2*(360-Delta_Y),d1
RotationY:
	move.w d1,angle_Y-Main(a6)

;----- calcul les coordonnees -----

	lea cosinus(pc),a3
	move.w angle_X(pc),d0
	move.w (a3,d0.w),d3
	lea sinus(pc),a3
	move.w angle_Y(pc),d0
	move.w (a3,d0.w),d4
	movea.l coor_adr(pc),a1
	lea Scene_Start(pc),a2
	rept $40
	move.w (a2)+,d0
	move.w (a2)+,d1
	muls d3,d0
	swap d0
	rol.l #1,d0
	muls d4,d1
	swap d1
	rol.l #1,d1
	move.w d0,d2
	add.w #sizex/2,d0
	add.w #sizey/2,d1
	move.w d0,(a1)+
	move.w d1,(a1)+
	neg d2
	add.w #160,d2
	move.w d2,(a1)+
	move.w d1,(a1)+
	endr

;------ trace les lignes ------

	WaitBlit
	move.w #$FFFF,bltbdat(a5)	;motif droite
	lea Line_Start(pc),a1
	movea.l coor_adr(pc),a2
	move.w #sizex/8,bltcmod(a5)
	move.w #sizex/8,bltdmod(a5)
	move.w #$8000,bltafwm(a5)
	move.w #$8000,bltadat(a5)
	rept $7E
	move.w (a1)+,d0
	move.w 2(a2,d0.w),d1
	move.w (a2,d0.w),d0
	move.w (a1)+,d2
	move.w 2(a2,d2.w),d3
	move.w (a2,d2.w),d2
	bsr DrawLine
	endr

;----- remplissage de surface -----

	WaitBlit
	move.w #12,bltbmod(a5)
	move.w #12,bltdmod(a5)
	move.w #%0000010111001100,bltcon0(a5)
	move.w #%0000000000001010,bltcon1(a5)
	lea planesize-2-6(a0),a1
	move.l a1,bltbpth(a5)
	move.l a1,bltdpth(a5)
	move.w #sizex/16-6+64*sizey,bltsize(a5)

;----- leftclick -----

	btst #6,$bfe001
	bne Main_Loop
	tst.w d7
	bge Main_Exiting
	move.w #(sizey+2)/2-1,d7
Main_Exiting:
	bra Main_Loop

;----- fin ------

Main_End:
	WaitBlit
	bsr module_adr+16
	bsr module_adr+8
	bsr Fin

;----- restauration registres -----

	movem.l (sp)+,d1-d3
	movem.l (sp)+,d0-d7/a0-a6

	rts

;*************** TRACE DE DROITES ***************

;Entree:
;	A0=adresse bitplane
;	D0=Xi
;	D1=Yi
;	D2=Xf
;	D3=Yf

;A4,D5,D6

DrawLine:

;----- ordonnancement des points -----

	cmp.w d1,d3
	beq DrawLine_End
	bge DrawLine_UpDown
	exg d0,d2
	exg d1,d3
DrawLine_UpDown:
	subq.w #1,d3

;------ calcul adresse de depart de la droite -----
	
	moveq #0,d6
	move.w d1,d6
	lsl.l #3,d6
	move.l d6,d5
	lsl.l #2,d5
	add.l d5,d6		;d6=y1*nbre octets par ligne
	add.l a0,d6		;+adresse depart bitplane
	moveq #0,d5
	move.w d0,d5
	lsr.w #3,d5
	bclr #0,d5
	add.l d5,d6		;+x1/8

;----- recherche de l'octant -----

	moveq #0,d5
	sub.w d1,d3	;d3=Dy=y2-y1
	bpl.b Dy_pos
	bset #2,d5
	neg d3
Dy_pos:	
	sub.w d0,d2	;d2=Dx=x2-x1
	bpl.b Dx_pos
	bset #1,d5
	neg d2
Dx_pos:
	cmp.w d3,d2	;Dx-Dy
	bpl.b DxDy_pos
	bset #0,d5
	exg d3,d2	;ainsi d3=Pdelta et d2=Gdelta
DxDy_pos:
	add.w d3,d3	;d3=2*Pdelta

;----- BLTCON0 -----
	
	and.w #$F,d0
	ror.w #4,d0
	or.w #$B4A,d0

;----- BLTCON1 -----

	lea Octant(pc),a4
	move.b (a4,d5.w),d5
	lsl #2,d5
	bset #0,d5
	bset #1,d5

;----- attente blitter -----

	WaitBlit

;----- BLTCON1, BLTBMOD, BLTAPTL, BLTAMOD -----

	move.w d3,bltbmod(a5)
	sub.w d2,d3
	bge.s DrawLine_NoBit
	bset #6,d5
DrawLine_NoBit:
	move.w d3,bltaptl(a5)
	sub.w d2,d3
	move.w d3,bltamod(a5)

;----- BLTSIZE -----

	lsl #6,d2
	add.w #66,d2

;----- lancement blitter -----

	move.w d5,bltcon1(a5)
	move.w d0,bltcon0(a5)
	move.l d6,bltcpth(a5)
	move.l d6,bltdpth(a5)
	move.w d2,bltsize(a5)

;----- fin -----

DrawLine_End:

	rts

;*************** PRINTER ***************

;A0=adresse screen
;A1=adresse texte
;A2=adresse font

Printer:

	movea.l a0,a3
Printer_Loop:
	moveq #0,d0
	move.b (a1)+,d0
	cmp.b #$A,d0			;fin de ligne ?
	beq Printer_EOL
	cmp.b #$1B,d0			;fin de page ?
	beq Printer_EOP
	subi.b #$20,d0
	lsl.w #3,d0
	movea.l a3,a5
	lea (a2,d0.w),a4
	rept 8
	move.b (a4)+,(a5)
	lea sizex/8(a5),a5
	endr
	addq.w #1,a3			;caractere suivant
	bra Printer_Loop
Printer_EOL:
	lea 8*sizex/8(a0),a0		;passe a la ligne
	movea.l a0,a3
	bra Printer_Loop
Printer_EOP:
	addq.w #1,a1			;avale le return apres le $1B

	rts

;*************** INITIALISATION ***************

Init:
	lea Init(pc),a5

;----- reservation de la memoire buffer_adr -----

	move.l #planesize,d0
	move.l #memory,d1
	CALLEXEC AllocMem
	move.l d0,buffer_adr-Init(a5)

;----- reservation de la memoire screen -----

	move.l #planesize*(nbplane-1+2),d0
	move.l #memory,d1
	CALLEXEC AllocMem
	move.l d0,screen_adr-Init(a5)

;----- reservation de la memoire cordoonnees -----

	move.l #coorsize,d0
	move.l #memory,d1
	CALLEXEC AllocMem
	move.l d0,coor_adr-Init(a5)

;---- reservation de la memoire copper -----

	move.l #copsize,d0
	move.l #memory,d1
	CALLEXEC AllocMem
	move.l d0,cop_adr-Init(a5)

;----- creation de la copperlist -----

	movea.l cop_adr(pc),a0

	move.l #$01800000,(a0)+
	move.l #$01820550,(a0)+
	move.l #$01840550,(a0)+
	move.l #$01860990,(a0)+
	move.l #$01880550,(a0)+
	move.l #$018A0BB0,(a0)+
	move.l #$018C0990,(a0)+
	move.l #$018E0DD0,(a0)+
	move.l #$01900006,(a0)+
	move.l #$01920550,(a0)+
	move.l #$01940550,(a0)+
	move.l #$01960990,(a0)+
	move.l #$01980550,(a0)+
	move.l #$019A0BB0,(a0)+
	move.l #$019C0990,(a0)+
	move.l #$019E0DD0,(a0)+

	move.l #$01A00FFF,(a0)+
	move.l #$01A20FFF,(a0)+
	move.l #$01A40FFF,(a0)+
	move.l #$01A60FFF,(a0)+
	move.l #$01A80FFF,(a0)+
	move.l #$01AA0FFF,(a0)+
	move.l #$01AC0FFF,(a0)+
	move.l #$01AE0FFF,(a0)+
	move.l #$01B00FFF,(a0)+
	move.l #$01B20FFF,(a0)+
	move.l #$01B40FFF,(a0)+
	move.l #$01B60FFF,(a0)+
	move.l #$01B80FFF,(a0)+
	move.l #$01BA0FFF,(a0)+
	move.l #$01BC0FFF,(a0)+
	move.l #$01BE0FFF,(a0)+

	move.w #$008E,(a0)+		;DIWSTRT
	move.w #starty*256+startdisplayx,(a0)+
	move.w #$0090,(a0)+		;DIWSTOP
	move.w #stopy*256+stopx,(a0)+
	move.w #$0100,(a0)+		;BPLCON0
	move.w #nbplane,d0
	ror.w #4,d0
	bset #9,d0
	move.w d0,(a0)+
	move.w #$0102,(a0)+		;BPLCON1
	move.w #$0000,(a0)+
	move.w #$0104,(a0)+		;BPLCON2
	move.w #$0000,(a0)+
	move.w #$0092,(a0)+		;DDFSTRT
	move.w #ddf_strt,(a0)+
	move.w #$0094,(a0)+		;DDFSTOP
	move.w #ddf_stop,(a0)+
	move.w #$0108,(a0)+		;BPL1MOD
	move.w #modulo_pair,(a0)+
	move.w #$010A,(a0)+		;BPL2MOD
	move.w #modulo_impair,(a0)+
	move.l #$01FC0000,(a0)+
	move.l #$01060000,(a0)+

	move.w #$E0,d1
	move.l screen_adr(pc),d0
	move.w #nbplane-3,d2
Init_Loop:
	move.w d1,(a0)+
	swap d0
	move.w d0,(a0)+
	addq.w #2,d1
	move.w d1,(a0)+
	swap d0
	move.w d0,(a0)+
	addq.w #2,d1
	add.l #planesize,d0
	dbf d2,Init_Loop

	lea logo_adr(pc),a1
	move.l a1,d2
	move.w d1,(a0)+
	swap d2
	move.w d2,(a0)+
	addq.w #2,d1
	move.w d1,(a0)+
	swap d2
	move.w d2,(a0)+
	addq.w #2,d1

	move.w d1,(a0)+
	swap d0
	move.w d0,(a0)+
	addq.w #2,d1
	move.w d1,(a0)+
	swap d0
	move.w d0,(a0)+

	move.w #starty-1,d0
	lsl.w #8,d0
	or.w #$01,d0
	rept sizey+3
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	add.w #$0100,d0
	move.l #$01800000,(a0)+
	move.l #$00960100,(a0)+
	endr

	move.l #$FFFFFFFE,(a0)

;----- forbid -----

	CALLEXEC Forbid

;----- modif DMA,... -----

	lea $DFF000,a5
	lea Init(pc),a4
	move.w dmaconr(a5),dmacon_bak-Init(a4)
	move.w intenar(a5),intena_bak-Init(a4)
	move.w #$7FFF,intena(a5)
	move.w #$7FFF,intreq(a5)
	move.w #$7FFF,dmacon(a5)
	move.w #$2E-1,d0
	lea $8,a0
	lea vectors_bak(pc),a1
	lea vectors_end(pc),a2
Init_VecLoop:
	move.l (a0),(a1)+
	move.l a2,(a0)+
	dbf d0,Init_VecLoop
	move.l cop_adr(pc),cop1lch(a5)
	clr.w copjmp1(a5)
	move.w #$87C0,dmacon(a5)	;COPEN, BPLEN, BLTPRI, DMAEN

	rts

;*************** FIN DE PROGRAMME ***************

Fin:	

;----- restauration des canaux DMA, ... ----

	move.w #$2E-1,d0
	lea vectors_bak(pc),a0
	lea $8,a1
Fin_VecLoop:
	move.l (a0)+,(a1)+
	dbf d0,Fin_VecLoop
	move.w dmacon_bak(pc),d0
	bset #15,d0
	move.w d0,dmacon(a5)
	move.w intena_bak(pc),d0
	bset #15,d0
	move.w d0,intena(a5)

;----- permit -----

	CALLEXEC Permit

;----- liberation memoire screen -----

	movea.l screen_adr(pc),a1
	move.l #planesize*(nbplane-1+2),d0
	CALLEXEC FreeMem

;----- liberation memoire buffer -----
	
	movea.l buffer_adr(pc),a1
	move.l #planesize,d0
	CALLEXEC FreeMem

;----- liberation memoire copper -----

	movea.l cop_adr(pc),a1
	move.l #copsize,d0
	CALLEXEC FreeMem

;----- liberation memoire coordonnees -----

	movea.l coor_adr(pc),a1
	move.l #coorsize,d0
	CALLEXEC FreeMem

;----- restaurer la copperlist dos -----

	lea gfx_name(pc),a1
	CALLEXEC OldOpenLibrary
	move.l d0,a1
	move.l 38(a1),cop1lch(a5)
	clr.w copjmp1(a5)
	CALLEXEC CloseLibrary

	rts

;*************** VARIABLES ***************

vectors_end:	rte
vectors_bak:	dcb.l $2E
dmacon_bak:	dc.w 0
intena_bak:	dc.w 0
screen_adr:	dc.l 0
angle_X:	dc.w 0
angle_Y:	dc.w 0
buffer_adr:	dc.l 0
cop_adr:	dc.l 0
coor_adr:	dc.l 0
page_script:
	dc.w 0,sizeY/Page_speed	;1 page en haut
	dc.w 0,sizeY/Page_speed	;1 page en haut
	dc.w sizeY/Page_speed,0	;1 page en bas
	dc.w sizeY/Page_speed,0	;1 page en bas
font8_adr:	incbin "logo.fnt"
logo_adr:	incbin "flt.raw"
text_adr:	incbin "flt.txt"
gfx_name:	dc.b 'graphics.library',0
	even

sinus:
	dc.w 0,572,1144,1715,2286,2856
	dc.w 3425,3993,4560,5126,5690
	dc.w 6252,6813,7371,7927,8481
	dc.w 9032,9580,10126,10668,11207
	dc.w 11743,12275,12803,13328,13848
	dc.w 14365,14876,15384,15886,16384
	dc.w 16877,17364,17847,18324,18795
	dc.w 19261,19720,20174,20622,21063
	dc.w 21498,21926,22348,22763,23170
	dc.w 23571,23965,24351,24730,25102
	dc.w 25466,25822,26170,26510,26842
	dc.w 27166,27482,27789,28088,28378
	dc.w 28660,28932,29196,29452,29698
	dc.w 29935,30163,30382,30592,30792
	dc.w 30983,31164,31336,31499,31651
	dc.w 31795,31928,32052,32166,32270
	dc.w 32365,32449,32524,32588,32643
	dc.w 32688,32723,32748,32763,32767

	dc.w 32763,32748,32723,32688
	dc.w 32643,32588,32524,32449,32365
	dc.w 32270,32166,32052,31928,31795
	dc.w 31651,31499,31336,31164,30983
	dc.w 30792,30592,30382,30163,29935
	dc.w 29698,29452,29196,28932,28660
	dc.w 28378,28088,27789,27482,27166
	dc.w 26842,26510,26170,25822,25466
	dc.w 25102,24730,24351,23965,23571
	dc.w 23170,22763,22348,21926,21498
	dc.w 21063,20622,20174,19720,19261
	dc.w 18795,18324,17847,17364,16877
	dc.w 16384,15886,15384,14876,14365
	dc.w 13848,13328,12803,12275,11743
	dc.w 11207,10668,10126,9580,9032
	dc.w 8481,7927,7371,6813,6252
	dc.w 5690,5126,4560,3993,3425
	dc.w 2856,2286,1715,1144,572,0

	dc.w -572,-1144,-1715,-2286,-2856
	dc.w -3425,-3993,-4560,-5126,-5690
	dc.w -6252,-6813,-7371,-7927,-8481
	dc.w -9032,-9580,-10126,-10668,-11207
	dc.w -11743,-12275,-12803,-13328,-13848
	dc.w -14365,-14876,-15384,-15886,-16384
	dc.w -16877,-17364,-17847,-18324,-18795
	dc.w -19261,-19720,-20174,-20622,-21063
	dc.w -21498,-21926,-22348,-22763,-23170
	dc.w -23571,-23965,-24351,-24730,-25102
	dc.w -25466,-25822,-26170,-26510,-26842
	dc.w -27166,-27482,-27789,-28088,-28378
	dc.w -28660,-28932,-29196,-29452,-29698
	dc.w -29935,-30163,-30382,-30592,-30792
	dc.w -30983,-31164,-31336,-31499,-31651
	dc.w -31795,-31928,-32052,-32166,-32270
	dc.w -32365,-32449,-32524,-32588,-32643
	dc.w -32688,-32723,-32748,-32763,-32767

	dc.w -32763,-32748,-32723,-32688
	dc.w -32643,-32588,-32524,-32449,-32365
	dc.w -32270,-32166,-32052,-31928,-31795
	dc.w -31651,-31499,-31336,-31164,-30983
	dc.w -30792,-30592,-30382,-30163,-29935
	dc.w -29698,-29452,-29196,-28932,-28660
	dc.w -28378,-28088,-27789,-27482,-27166
	dc.w -26842,-26510,-26170,-25822,-25466
	dc.w -25102,-24730,-24351,-23965,-23571
	dc.w -23170,-22763,-22348,-21926,-21498
	dc.w -21063,-20622,-20174,-19720,-19261
	dc.w -18795,-18324,-17847,-17364,-16877
	dc.w -16384,-15886,-15384,-14876,-14365
	dc.w -13848,-13328,-12803,-12275,-11743
	dc.w -11207,-10668,-10126,-9580,-9032
	dc.w -8481,-7927,-7371,-6813,-6252
	dc.w -5690,-5126,-4560,-3993,-3425
	dc.w -2856,-2286,-1715,-1144,-572

cosinus:	
	dc.w 32767,32763,32748,32723,32688
	dc.w 32643,32588,32524,32449,32365
	dc.w 32270,32166,32052,31928,31795
	dc.w 31651,31499,31336,31164,30983
	dc.w 30792,30592,30382,30163,29935
	dc.w 29698,29452,29196,28932,28660
	dc.w 28378,28088,27789,27482,27166
	dc.w 26842,26510,26170,25822,25466
	dc.w 25102,24730,24351,23965,23571
	dc.w 23170,22763,22348,21926,21498
	dc.w 21063,20622,20174,19720,19261
	dc.w 18795,18324,17847,17364,16877
	dc.w 16384,15886,15384,14876,14365
	dc.w 13848,13328,12803,12275,11743
	dc.w 11207,10668,10126,9580,9032
	dc.w 8481,7927,7371,6813,6252
	dc.w 5690,5126,4560,3993,3425
	dc.w 2856,2286,1715,1144,572,0

	dc.w -572,-1144,-1715,-2286,-2856
	dc.w -3425,-3993,-4560,-5126,-5690
	dc.w -6252,-6813,-7371,-7927,-8481
	dc.w -9032,-9580,-10126,-10668,-11207
	dc.w -11743,-12275,-12803,-13328,-13848
	dc.w -14365,-14876,-15384,-15886,-16384
	dc.w -16877,-17364,-17847,-18324,-18795
	dc.w -19261,-19720,-20174,-20622,-21063
	dc.w -21498,-21926,-22348,-22763,-23170
	dc.w -23571,-23965,-24351,-24730,-25102
	dc.w -25466,-25822,-26170,-26510,-26842
	dc.w -27166,-27482,-27789,-28088,-28378
	dc.w -28660,-28932,-29196,-29452,-29698
	dc.w -29935,-30163,-30382,-30592,-30792
	dc.w -30983,-31164,-31336,-31499,-31651
	dc.w -31795,-31928,-32052,-32166,-32270
	dc.w -32365,-32449,-32524,-32588,-32643
	dc.w -32688,-32723,-32748,-32763,-32767

	dc.w -32763,-32748,-32723,-32688
	dc.w -32643,-32588,-32524,-32449,-32365
	dc.w -32270,-32166,-32052,-31928,-31795
	dc.w -31651,-31499,-31336,-31164,-30983
	dc.w -30792,-30592,-30382,-30163,-29935
	dc.w -29698,-29452,-29196,-28932,-28660
	dc.w -28378,-28088,-27789,-27482,-27166
	dc.w -26842,-26510,-26170,-25822,-25466
	dc.w -25102,-24730,-24351,-23965,-23571
	dc.w -23170,-22763,-22348,-21926,-21498
	dc.w -21063,-20622,-20174,-19720,-19261
	dc.w -18795,-18324,-17847,-17364,-16877
	dc.w -16384,-15886,-15384,-14876,-14365
	dc.w -13848,-13328,-12803,-12275,-11743
	dc.w -11207,-10668,-10126,-9580,-9032
	dc.w -8481,-7927,-7371,-6813,-6252
	dc.w -5690,-5126,-4560,-3993,-3425
	dc.w -2856,-2286,-1715,-1144,-572

	dc.w 0,572,1144,1715,2286,2856
	dc.w 3425,3993,4560,5126,5690
	dc.w 6252,6813,7371,7927,8481
	dc.w 9032,9580,10126,10668,11207
	dc.w 11743,12275,12803,13328,13848
	dc.w 14365,14876,15384,15886,16384
	dc.w 16877,17364,17847,18324,18795
	dc.w 19261,19720,20174,20622,21063
	dc.w 21498,21926,22348,22763,23170
	dc.w 23571,23965,24351,24730,25102
	dc.w 25466,25822,26170,26510,26842
	dc.w 27166,27482,27789,28088,28378
	dc.w 28660,28932,29196,29452,29698
	dc.w 29935,30163,30382,30592,30792
	dc.w 30983,31164,31336,31499,31651
	dc.w 31795,31928,32052,32166,32270
	dc.w 32365,32449,32524,32588,32643
	dc.w 32688,32723,32748,32763

Scene_Start:
	dc.w -42,-102
	dc.w -80,-86
	dc.w -88,-56
	dc.w -68,-36
	dc.w -36,-44
	dc.w -28,-68
	dc.w -48,-64
	dc.w -54,-78
	dc.w -44,-68
	dc.w -30,-70
	dc.w -36,-86
	dc.w -68,-32
	dc.w -64,-20
	dc.w -36,-34
	dc.w -36,-40
	dc.w -62,-16
	dc.w -52,-4
	dc.w -32,-22
	dc.w -34,-30
	dc.w -22,-44
	dc.w -24,-36
	dc.w -10,-38

	dc.w 0,-36
	dc.w -32,-32
	dc.w -28,-22
	dc.w -50,0
	dc.w -40,32
	dc.w 0,36

	dc.w -52,2
	dc.w -70,6
	dc.w -70,12
	dc.w -50,10
	dc.w -72,6
	dc.w -72,12
	dc.w -90,12
	dc.w -90,8
	dc.w -92,8
	dc.w -92,12
	dc.w -108,8
	dc.w -108,6

	dc.w -50,14
	dc.w -48,22
	dc.w -66,28
	dc.w -66,22
	dc.w -68,28
	dc.w -68,22
	dc.w -86,28
	dc.w -86,32
	dc.w -88,32
	dc.w -88,28
	dc.w -106,30
	dc.w -106,32

	dc.w -46,24
	dc.w -44,32
	dc.w -62,44
	dc.w -62,36
	dc.w -64,44
	dc.w -64,38
	dc.w -78,48
	dc.w -78,52
	dc.w -80,52
	dc.w -80,48
	dc.w -98,52
	dc.w -98,54
Scene_End:

Line_Start:
;pinces (big part)

	dc.w 0*4,2*4
	dc.w 2*4,4*4
	dc.w 4*4,6*4
	dc.w 6*4,8*4
	dc.w 8*4,10*4
	dc.w 10*4,12*4
	dc.w 12*4,14*4
	dc.w 14*4,0*4

	dc.w 1*4,3*4
	dc.w 3*4,5*4
	dc.w 5*4,7*4
	dc.w 7*4,9*4
	dc.w 9*4,11*4
	dc.w 11*4,13*4
	dc.w 13*4,15*4
	dc.w 15*4,1*4

;pinces (small part)

	dc.w 16*4,18*4
	dc.w 18*4,20*4
	dc.w 20*4,16*4

	dc.w 17*4,19*4
	dc.w 19*4,21*4
	dc.w 21*4,17*4

;bras

	dc.w 22*4,24*4
	dc.w 24*4,26*4
	dc.w 26*4,28*4
	dc.w 28*4,22*4
	dc.w 30*4,32*4
	dc.w 32*4,34*4
	dc.w 34*4,36*4
	dc.w 36*4,30*4

	dc.w 23*4,25*4
	dc.w 25*4,27*4
	dc.w 27*4,29*4
	dc.w 29*4,23*4
	dc.w 31*4,33*4
	dc.w 33*4,35*4
	dc.w 35*4,37*4
	dc.w 37*4,31*4

;yeux

	dc.w 38*4,40*4
	dc.w 40*4,42*4
	dc.w 42*4,38*4

	dc.w 39*4,41*4
	dc.w 41*4,43*4
	dc.w 43*4,39*4

;corps

	dc.w 44*4,46*4
	dc.w 46*4,48*4
	dc.w 48*4,50*4
	dc.w 50*4,52*4
	dc.w 52*4,54*4
	dc.w 54*4,53*4
	dc.w 53*4,51*4
	dc.w 51*4,49*4
	dc.w 49*4,47*4
	dc.w 47*4,44*4

;pattes

	dc.w 56*4,58*4
	dc.w 58*4,60*4
	dc.w 60*4,62*4
	dc.w 62*4,56*4
	dc.w 64*4,66*4
	dc.w 66*4,68*4
	dc.w 68*4,70*4
	dc.w 70*4,64*4
	dc.w 72*4,74*4
	dc.w 74*4,76*4
	dc.w 76*4,78*4
	dc.w 78*4,72*4

	dc.w 80*4,82*4
	dc.w 82*4,84*4
	dc.w 84*4,86*4
	dc.w 86*4,80*4
	dc.w 88*4,90*4
	dc.w 90*4,92*4
	dc.w 92*4,94*4
	dc.w 94*4,88*4
	dc.w 96*4,98*4
	dc.w 98*4,100*4
	dc.w 100*4,102*4
	dc.w 102*4,96*4

	dc.w 104*4,106*4
	dc.w 106*4,108*4
	dc.w 108*4,110*4
	dc.w 110*4,104*4
	dc.w 112*4,114*4
	dc.w 114*4,116*4
	dc.w 116*4,118*4
	dc.w 118*4,112*4
	dc.w 120*4,122*4
	dc.w 122*4,124*4
	dc.w 124*4,126*4
	dc.w 126*4,120*4

	dc.w 57*4,59*4
	dc.w 59*4,61*4
	dc.w 61*4,63*4
	dc.w 63*4,57*4
	dc.w 65*4,67*4
	dc.w 67*4,69*4
	dc.w 69*4,71*4
	dc.w 71*4,65*4
	dc.w 73*4,75*4
	dc.w 75*4,77*4
	dc.w 77*4,79*4
	dc.w 79*4,73*4

	dc.w 81*4,83*4
	dc.w 83*4,85*4
	dc.w 85*4,87*4
	dc.w 87*4,81*4
	dc.w 89*4,91*4
	dc.w 91*4,93*4
	dc.w 93*4,95*4
	dc.w 95*4,89*4
	dc.w 97*4,99*4
	dc.w 99*4,101*4
	dc.w 101*4,103*4
	dc.w 103*4,97*4

	dc.w 105*4,107*4
	dc.w 107*4,109*4
	dc.w 109*4,111*4
	dc.w 111*4,105*4
	dc.w 113*4,115*4
	dc.w 115*4,117*4
	dc.w 117*4,119*4
	dc.w 119*4,113*4
	dc.w 121*4,123*4
	dc.w 123*4,125*4
	dc.w 125*4,127*4
	dc.w 127*4,121*4
Line_End:

scenesize=Scene_End-Scene_Start
linesize=Line_End-Line_Start
coorsize=2*scenesize		;double car symetrie

;table des octants: y2-y1,x2-x1,Dx-Dy
;si <0 alors 0 si >=0 alors 1. Par exemple: 
;	y2-y1<0 	donc 1
;	x2-x1<0 	donc 1
;	Dx-Dy<0		donc 1
;le code octant est donc le .b qui se trouve a l'adresse octant+111
	
octant:
	dc.b 4	;000 y1<y2 x1<x2 Dx>Dy		 
	dc.b 0	;001 y1<y2 x1<x2 Dx<Dy
	dc.b 5	;010 y1<y2 x1>x2 Dx>Dy
	dc.b 2	;011 y1<y2 x1>x2 Dx<Dy
	dc.b 6	;100 y1>y2 x1<x2 Dx>Dy
	dc.b 1	;101 y1>y2 x1<x2 Dx<Dy	
	dc.b 7	;110 y1>y2 x1>x2 Dx>Dy	
	dc.b 3	;111 y1>y2 x1>x2 Dx<Dy
	even

module_adr:	incbin "mod.hold_of_fame.pc"
